"""Driver for transferlite"""

import threading
import sys
import json
import time
import logging
from random import randint
from device_base import deviceBase
from Channel import PLCChannel, read_tag, write_tag
import persistence
from utilities import get_public_ip_address


_ = None

# LOGGING SETUP
from logging.handlers import RotatingFileHandler

log_formatter = logging.Formatter('%(asctime)s %(levelname)s %(funcName)s(%(lineno)d) %(message)s')
logFile = './transferlite.log'
my_handler = RotatingFileHandler(logFile, mode='a', maxBytes=500*1024,
                                 backupCount=2, encoding=None, delay=0)
my_handler.setFormatter(log_formatter)
my_handler.setLevel(logging.INFO)
logger = logging.getLogger('transferlite')
logger.setLevel(logging.INFO)
logger.addHandler(my_handler)

console_out = logging.StreamHandler(sys.stdout)
console_out.setFormatter(log_formatter)
logger.addHandler(console_out)

logger.info("transferlite startup")

# GLOBAL VARIABLES
WAIT_FOR_CONNECTION_SECONDS = 15
WATCHDOG_ENABLE = True
WATCHDOG_SEND_PERIOD = 3600  # Seconds, the longest amount of time before sending watchdog status
PLC_IP_ADDRESS = "10.20.4.37"
CHANNELS = [
    PLCChannel(PLC_IP_ADDRESS, "ft01_flowmeter_bpd", "FT01_Flowmeter_BPD", "REAL", 100.0, 600),
    PLCChannel(PLC_IP_ADDRESS, "auto_manual", "sts_autoMode", "BOOL", 1, 600),
    PLCChannel(PLC_IP_ADDRESS, "ft01_flowmeter_gpm", "FT01_Flowmeter.val", "REAL", 10.0, 600),
    PLCChannel(PLC_IP_ADDRESS, "lt11_pondlevel", "LT11_PondLevel.val", "REAL", 1.0, 600),
    PLCChannel(PLC_IP_ADDRESS, "lt21_pondlevel", "LT21_PondLevel.val", "REAL", 1.0, 600),
    PLCChannel(PLC_IP_ADDRESS, "pt11_dischargepressure", "PT11_DischargePressure.val", "REAL", 10, 600),
    PLCChannel(PLC_IP_ADDRESS, "pt21_dischargepressure", "PT21_DischargePressure.val", "REAL", 10, 600),
    PLCChannel(PLC_IP_ADDRESS, "flow_rate_setpoint", "set_FlowRateSetpoint", "REAL", 1.0, 600),
    PLCChannel(PLC_IP_ADDRESS, "system1_frequency_setpoint", "set_ManualFrequencySP_System1", "REAL", 1.0, 600),
    PLCChannel(PLC_IP_ADDRESS, "system2_frequency_setpoint", "set_ManualFrequencySP_System2", "REAL", 1.0, 600),
    PLCChannel(PLC_IP_ADDRESS, "ft01_flowmeter_bpd_yesterday", "FT01_Flowmeter_History[1]", "REAL", 1.0, 600),
    PLCChannel(PLC_IP_ADDRESS, "ft01_flowmeter_bpd_today", "FT01_Flowmeter_History[0]", "REAL",100.0, 600)
]

# PERSISTENCE FILE
PERSIST = persistence.load()


class start(threading.Thread, deviceBase):
    """Start class required by Meshify."""

    def __init__(self, name=None, number=None, mac=None, Q=None, mcu=None,
                 companyId=None, offset=None, mqtt=None, Nodes=None):
        """Initialize the driver."""
        threading.Thread.__init__(self)
        deviceBase.__init__(self, name=name, number=number, mac=mac, Q=Q,
                            mcu=mcu, companyId=companyId, offset=offset,
                            mqtt=mqtt, Nodes=Nodes)

        self.daemon = True
        self.version = "1"
        self.finished = threading.Event()
        self.force_send = False
        self.public_ip_address = ""
        self.public_ip_address_last_checked = 0
        self.watchdog = False
        self.watchdog_last_checked = 0
        self.watchdog_last_sent = 0
        threading.Thread.start(self)

    # this is a required function for all drivers, its goal is to upload some piece of data
    # about your device so it can be seen on the web
    def register(self):
        """Register the driver."""
        self.sendtodb("log", "BOOM! Booted.", 0)

    def run(self):
        """Actually run the driver."""
        for i in range(0, WAIT_FOR_CONNECTION_SECONDS):
            print("transferlite driver will start in {} seconds".format(WAIT_FOR_CONNECTION_SECONDS - i))
            time.sleep(1)
        logger.info("BOOM! Starting transferlite driver...")

        self._check_ip_address()
        self._check_watchdog()

        self.nodes["transferlite_0199"] = self

        send_loops = 0
        watchdog_check_after = 60
        ip_check_after = 60

        while True:
            now = time.time()
            if self.force_send:
                logger.warning("FORCE SEND: TRUE")

            for chan in CHANNELS:
                read_val = chan.read()
                if read_val is not None:  # read returns None if it fails
                    if chan.check(read_val, self.force_send):
                        self.sendtodbDev(1, chan.mesh_name, chan.value, 0, 'transferlite')


            # print("transferlite driver still alive...")
            if self.force_send:
                if send_loops > 2:
                    logger.warning("Turning off force_send")
                    self.force_send = False
                    send_loops = 0
                else:
                    send_loops += 1

            if WATCHDOG_ENABLE:
                if (now - self.watchdog_last_checked) > watchdog_check_after:
                    self._check_watchdog()

            if (now - self.public_ip_address_last_checked) > ip_check_after:
                self._check_ip_address()


    def _check_watchdog(self):
        """Check the watchdog and send to Meshify if changed or stale."""
        test_watchdog = self.transferlite_watchdog()
        now = time.time()
        self.watchdog_last_checked = now
        if test_watchdog != self.watchdog or (now - self.watchdog_last_sent) > WATCHDOG_SEND_PERIOD:
            self.sendtodbDev(1, 'watchdog', test_watchdog, 0, 'transferlite')
            self.watchdog = test_watchdog
            self.watchdog_last_sent = now


    def _check_ip_address(self):
        """Check the public IP address and send to Meshify if changed."""
        self.public_ip_address_last_checked = time.time()
        test_public_ip = get_public_ip_address()
        if not test_public_ip == self.public_ip_address:
            self.sendtodbDev(1, 'public_ip_address', test_public_ip, 0, 'transferlite')
            self.public_ip_address = test_public_ip

    def transferlite_watchdog(self):
        """Write a random integer to the PLC and then 1 seconds later check that it has been decremented by 1."""
        randval = randint(0, 32767)
        write_tag(str(PLC_IP_ADDRESS), 'watchdog_INT', randval)
        time.sleep(1)
        watchdog_val = read_tag(str(PLC_IP_ADDRESS), 'watchdog_INT')
        try:
            return (randval - 1) == watchdog_val[0]
        except (KeyError, TypeError):
            return False

    def transferlite_sync(self, name, value):
        """Sync all data from the driver."""
        self.force_send = True
        # self.sendtodb("log", "synced", 0)
        return True

    def transferlite_writeplctag(self, name, value):
        """Write a value to the PLC."""
        new_val = json.loads(str(value).replace("'", '"'))
        tag_n = str(new_val['tag'])  # "cmd_Start"
        val_n = new_val['val']
        w = write_tag(str(PLC_IP_ADDRESS), tag_n, val_n)
        logger.info("Result of transferlite_writeplctag(self, {}, {}) = {}".format(name, value, w))
        if w is None:
            w = "Error writing to PLC..."
        return w
